【Leetcode 每日一题 - 补卡】1534. 统计好三元组

问题背景

给你一个整数数组 a r r arr arr,以及 a 、 b 、 c a、b 、c a、b、c 三个整数。请你统计其中好三元组的数量。

如果三元组 ( a r r i , a r r j , a r r k ) (arri, arrj, arrk) (arri,arrj,arrk) 满足下列全部条件,则认为它是一个 好三元组 。

  • 0 ≤ i < j < k < a r r . l e n g t h 0 \le i < j < k < arr.length 0≤i<j<k<arr.length
  • ∣ a r r i − a r r j ∣ ≤ a |arri - arrj| \le a ∣arri−arrj∣≤a
  • ∣ a r r j − a r r k ∣ ≤ b |arrj - arrk| \le b ∣arrj−arrk∣≤b
  • ∣ a r r i − a r r k ∣ ≤ c |arri - arrk| \le c ∣arri−arrk∣≤c

其中 ∣ x ∣ |x| ∣x∣ 表示 x x x 的绝对值。

返回 好三元组的数量 。

数据约束

  • 3 ≤ a r r . l e n g t h ≤ 100 3 \le arr.length \le 100 3≤arr.length≤100
  • 0 ≤ a r r i ≤ 1000 0 \le arri \le 1000 0≤arri≤1000
  • 0 ≤ a , b , c ≤ 1000 0 \le a, b, c \le 1000 0≤a,b,c≤1000

解题过程

题中要求的约束有三个,暴力枚举的时间复杂度是 O ( N 3 ) O(N ^ 3) O(N3)。

如果数组是有序的,那可以很容易地提高时间方面的效率,但是结果与元素的初始位置有关,所以不方便直接排序。

退而求其次,定义一个下标数组,对它进行排序。

然后将数组中的元素当作 j j j 来遍历,将满足 ∣ a r r i − a r r j ∣ ≤ a |arri - arrj| \le a ∣arri−arrj∣≤a 以及 ∣ a r r j − a r r k ∣ ≤ b |arrj - arrk| \le b ∣arrj−arrk∣≤b

两个条件的原数组中的元素分别记录到哈希表中。

接下来只要再求满足第三个条件的元素对的数量,根据绝对值的定义,可以在线性的时间内得到合法结果的上下限。

具体实现

java 复制代码
class Solution {
    public int countGoodTriplets(int[] arr, int a, int b, int c) {
        Integer[] idx = new Integer[arr.length];
        Arrays.setAll(idx, i -> i);
        Arrays.sort(idx, (i, j) -> arr[i] - arr[j]);

        int res = 0;
        for (int j : idx) {
            int cur = arr[j];
            List<Integer> list1 = new ArrayList<>();
            for (int i : idx) {
                if (i < j && Math.abs(arr[i] - cur) <= a) {
                    list1.add(arr[i]);
                }
            }

            List<Integer> list2 = new ArrayList<>();
            for (int k : idx) {
                if (k > j && Math.abs(arr[k] - cur) <= b) {
                    list2.add(arr[k]);
                }
            }

            int left = 0;
            int right = 0;
            for (int item : list1) {
                while (right < list2.size() && list2.get(right) <= item + c) {
                    right++;
                }
                while (left < list2.size() && list2.get(left) < item - c) {
                    left++;
                }
                res += right - left;
            }
        }
        return res;
    }
}
相关推荐
一去不复返的通信er1 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人4 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade5 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin7706 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君6587 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一7 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1007 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao8 小时前
算法56,重排链表
数据结构·算法·链表
qq_452396238 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin